import processing.serial.*;

int sen = 3; // sensors
float sensitivity = 25; // values bettween 15 and 40 are reasonable, default=25
int scalefactor=7; //factor for scaling the cube
String comPortString;
Serial myPort;
float xmag, ymag, zmag = 0;
float newXmag, newYmag, newZmag = 0; 
float[] xyz = new float[sen];
MomentumAverage axyz[] = new MomentumAverage[sen];
PFont myFont;

void setup()  { 
  //size(640, 360, P3D); 
  //size(1280, 720, P3D); 
  size(displayWidth,displayHeight, P3D); //Use entire screen size.
  smooth(); // draws all shapes with smooth edges.
  noStroke(); 
  colorMode(RGB, 1); 
  /*Open the serial port for communication with the Arduino
  Make sure the COM port is correct - I am using /dev/ttyACM0 */
  myPort = new Serial(this, "/dev/ttyACM0", 9600);
  //myPort.bufferUntil('\n'); // Trigger a SerialEvent on new line
    for(int i = 0; i < sen; i++) {
    axyz[i] = new MomentumAverage(0.1);
  }
} 


void serialEvent(Serial cPort){
    if ( myPort.available() > 0) {
       String cur = cPort.readStringUntil('\n');
         if(cur != null) {
            println(cur);
            String[] parts = split(cur, " ");
          if(parts.length == sen  ) {
              //println(sen);
              for(int i = 0; i < sen; i++){
                  xyz[i] = float(parts[i]);
                  axyz[i].note(xyz[i]);
                  xyz[i] = axyz[i].avg;
          
        }
     }
  }
    }
} 
void draw()  { 

  background(0.5);
  
  pushMatrix(); 
  translate(width/2, height/2, -30); 
  
  //newXmag = mouseX/float(width) * TWO_PI;
  //newYmag = mouseY/float(height) * TWO_PI;
  newXmag = xyz[0]/sensitivity * TWO_PI;
  newYmag = xyz[1]/sensitivity * TWO_PI;
  newZmag = xyz[2]/sensitivity *TWO_PI;
  
  float diff = xmag-newXmag;
  if (abs(diff) >  0.01) { 
    xmag -= diff/4.0; 
  }
  
  diff = ymag-newYmag;
  if (abs(diff) >  0.01) { 
    ymag -= diff/4.0; 
  }
  
  
  rotateX(-ymag); 
  rotateY(-xmag); 
  
  //scale(180);
  scale(xyz[2]*scalefactor);
  beginShape(QUADS);

  fill(0, 1, 1); vertex(-1,  1,  1);
  fill(1, 1, 1); vertex( 1,  1,  1);
  fill(1, 0, 1); vertex( 1, -1,  1);
  fill(0, 0, 1); vertex(-1, -1,  1);

  fill(1, 1, 1); vertex( 1,  1,  1);
  fill(1, 1, 0); vertex( 1,  1, -1);
  fill(1, 0, 0); vertex( 1, -1, -1);
  fill(1, 0, 1); vertex( 1, -1,  1);

  fill(1, 1, 0); vertex( 1,  1, -1);
  fill(0, 1, 0); vertex(-1,  1, -1);
  fill(0, 0, 0); vertex(-1, -1, -1);
  fill(1, 0, 0); vertex( 1, -1, -1);

  fill(0, 1, 0); vertex(-1,  1, -1);
  fill(0, 1, 1); vertex(-1,  1,  1);
  fill(0, 0, 1); vertex(-1, -1,  1);
  fill(0, 0, 0); vertex(-1, -1, -1);

  fill(0, 1, 0); vertex(-1,  1, -1);
  fill(1, 1, 0); vertex( 1,  1, -1);
  fill(1, 1, 1); vertex( 1,  1,  1);
  fill(0, 1, 1); vertex(-1,  1,  1);

  fill(0, 0, 0); vertex(-1, -1, -1);
  fill(1, 0, 0); vertex( 1, -1, -1);
  fill(1, 0, 1); vertex( 1, -1,  1);
  fill(0, 0, 1); vertex(-1, -1,  1);
  
   endShape();
  
  popMatrix(); 
} 